Index: palm/trunk/SOURCE/urban_surface_mod.f90
===================================================================
--- palm/trunk/SOURCE/urban_surface_mod.f90	(revision 3636)
+++ palm/trunk/SOURCE/urban_surface_mod.f90	(revision 3637)
@@ -28,4 +28,7 @@
 ! -----------------
 ! $Id$
+! Implementation of the PALM module interface
+! 
+! 3636 2018-12-19 13:48:34Z raasch
 ! nopointer option removed
 ! 
@@ -52,5 +55,5 @@
 ! 
 ! 3449 2018-10-29 19:36:56Z suehring
-! Bugfix: Fix average arrays allocations in usm_average_3d_data (J.Resler)
+! Bugfix: Fix average arrays allocations in usm_3d_data_averaging (J.Resler)
 ! Bugfix: Fix reading wall temperatures (J.Resler)
 ! Bugfix: Fix treating of outputs for wall temperature and sky view factors (J.Resler)
@@ -182,5 +185,5 @@
 ! 2906 2018-03-19 08:56:40Z Giersch
 ! Local variable ids has to be initialized with a value of -1 in 
-! usm_average_3d_data
+! usm_3d_data_averaging
 ! 
 ! 2894 2018-03-15 09:17:58Z Giersch
@@ -1125,7 +1128,7 @@
     END INTERFACE usm_allocate_surface
 
-    INTERFACE usm_average_3d_data
-       MODULE PROCEDURE usm_average_3d_data
-    END INTERFACE usm_average_3d_data
+    INTERFACE usm_3d_data_averaging
+       MODULE PROCEDURE usm_3d_data_averaging
+    END INTERFACE usm_3d_data_averaging
 
     
@@ -1138,5 +1141,5 @@
            usm_rrd_local,                                                      & 
            usm_surface_energy_balance, usm_material_heat_model,                &
-           usm_swap_timelevel, usm_check_data_output, usm_average_3d_data,     &
+           usm_swap_timelevel, usm_check_data_output, usm_3d_data_averaging,   &
            usm_data_output_3d, usm_define_netcdf_grid, usm_parin,              &
            usm_wrd_local, usm_allocate_surface
@@ -1563,5 +1566,5 @@
 !> the array necessary for storing the average.
 !------------------------------------------------------------------------------!
-    SUBROUTINE usm_average_3d_data( mode, variable )
+    SUBROUTINE usm_3d_data_averaging( mode, variable )
 
         IMPLICIT NONE
@@ -1575,4 +1578,6 @@
         CHARACTER(LEN=6), DIMENSION(0:nd-1), PARAMETER     :: dirname = (/ '_roof ', '_south', '_north', '_west ', '_east ' /)
         INTEGER(iwp), DIMENSION(0:nd-1), PARAMETER         :: dirint = (/ iup_u, isouth_u, inorth_u, iwest_u, ieast_u /)
+
+        IF ( variable(1:4) == 'usm_' )  THEN  ! is such a check really rquired?
 
 !--     find the real name of the variable
@@ -2447,5 +2452,7 @@
         ENDIF
 
-    END SUBROUTINE usm_average_3d_data
+        ENDIF
+
+    END SUBROUTINE usm_3d_data_averaging
 
 
Index: palm/trunk/SOURCE/write_restart_data_mod.f90
===================================================================
--- palm/trunk/SOURCE/write_restart_data_mod.f90	(revision 3636)
+++ palm/trunk/SOURCE/write_restart_data_mod.f90	(revision 3637)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Implementation of the PALM module interface
+! 
+! 3589 2018-11-30 15:09:51Z suehring
 ! Move the control parameter "salsa" from salsa_mod to control_parameters 
 ! (M. Kurppa)
@@ -69,11 +72,64 @@
 
 
+    USE arrays_3d,                                                          &
+        ONLY:  inflow_damping_factor, mean_inflow_profiles, pt_init,        &
+               q_init, ref_state, s_init, u_init, ug, v_init, vg,           &
+               e, kh, km, p, pt, q, ql, s, u, u_m_l, u_m_n, u_m_r,          &
+               u_m_s, v, v_m_l, v_m_n, v_m_r, v_m_s, vpt, w, w_m_l, w_m_n,  &
+               w_m_r, w_m_s
+
+    USE averaging
+
     USE control_parameters
- 
-    USE kinds     
+
+    USE date_and_time_mod,                                                     &
+        ONLY:  day_of_year_init, time_utc_init
+
+    USE grid_variables,                                                        &
+        ONLY:  dx, dy
+
+    USE indices,                                                               &
+        ONLY:  nx, nxl, nxr, ny, nys, nyn, nz, nzb, nzt
+
+    USE kinds
+
+    USE model_1d_mod,                                                          &
+        ONLY:  damp_level_1d, dt_pr_1d, dt_run_control_1d, end_time_1d
+
+    USE module_interface,                                                      &
+        ONLY:  module_interface_wrd_global,                                    &
+               module_interface_wrd_local
+
+    USE netcdf_interface,                                                      &
+        ONLY:  netcdf_precision, output_for_t0
+
+    USE particle_attributes,                                                   &
+        ONLY:  curvature_solution_effects, iran_part
 
     USE pegrid,                                                                &
-        ONLY:  myid, numprocs
-     
+        ONLY:  collective_wait, hor_index_bounds, myid, numprocs
+
+    USE radiation_model_mod,                                                   &
+        ONLY:  time_radiation
+
+    USE random_function_mod,                                                   &
+        ONLY:  random_iv, random_iy
+
+    USE random_generator_parallel,                                             &
+        ONLY:  id_random_array, seq_random_array
+
+    USE spectra_mod,                                                           &
+        ONLY:  average_count_sp, spectrum_x, spectrum_y
+
+    USE statistics,                                                            &
+        ONLY:  statistic_regions, hom, hom_sum, u_max, u_max_ijk, v_max,       &
+               v_max_ijk, w_max, w_max_ijk, z_i
+
+    USE surface_mod,                                                           &
+        ONLY :  surface_wrd_local
+
+    USE vertical_nesting_mod,                                                  &
+        ONLY:  vnest_init
+
 
     IMPLICIT NONE
@@ -103,66 +159,4 @@
     SUBROUTINE wrd_global
 
-
-       USE arrays_3d,                                                          &
-           ONLY:  inflow_damping_factor, mean_inflow_profiles, pt_init,        &
-                  q_init, ref_state, s_init, u_init, ug, v_init, vg
-
-       USE bulk_cloud_model_mod,                                               &
-           ONLY:  bulk_cloud_model, bcm_wrd_global
-
-       USE date_and_time_mod,                                                  &
-           ONLY:  day_of_year_init, time_utc_init
-
-       USE flight_mod,                                                         &
-           ONLY:  flight_wrd_global
-
-       USE grid_variables,                                                     &
-           ONLY:  dx, dy
-
-       USE gust_mod,                                                           &
-           ONLY :  gust_module_enabled, gust_wrd_global
-
-       USE indices,                                                            &
-           ONLY:  nx, ny, nz
-
-       USE model_1d_mod,                                                       &
-           ONLY:  damp_level_1d, dt_pr_1d, dt_run_control_1d, end_time_1d
-
-       USE netcdf_interface,                                                   &
-           ONLY:  netcdf_precision, output_for_t0
-
-       USE ocean_mod,                                                          &
-           ONLY:  ocean_wrd_global
-
-       USE particle_attributes,                                                &
-           ONLY:  curvature_solution_effects
-
-       USE pegrid,                                                             &
-           ONLY:  hor_index_bounds, collective_wait                                
-
-       USE radiation_model_mod,                                                &
-           ONLY:  time_radiation
-
-       USE spectra_mod,                                                        &
-           ONLY:  average_count_sp, spectrum_x, spectrum_y
-
-       USE synthetic_turbulence_generator_mod,                                 &
-           ONLY:  stg_wrd_global
-
-       USE statistics,                                                         &
-           ONLY:  statistic_regions, hom, hom_sum, u_max, u_max_ijk, v_max,    &
-                  v_max_ijk, w_max, w_max_ijk, z_i
-
-       USE user_write_restart_data_mod,                                        &
-           ONLY:  user_wrd_global 
-
-       USE vertical_nesting_mod,                                               &
-           ONLY:  vnest_init
-
-       USE wind_turbine_model_mod,                                             &
-           ONLY:  wtm_wrd_global
-     
-
-       IMPLICIT NONE
 
        CHARACTER (LEN=10)  ::  binary_version_global   !<
@@ -886,15 +880,5 @@
 !
 !--    Write restart data of the other modules
-!--    The order of the calls can be different as in read_restart_data_mod where
-!--    the restart data will be read
-       IF ( bulk_cloud_model )     CALL bcm_wrd_global
-       IF ( virtual_flight )       CALL flight_wrd_global
-       IF ( gust_module_enabled )  CALL gust_wrd_global
-       IF ( ocean_mode )           CALL ocean_wrd_global
-       IF ( syn_turb_gen )         CALL stg_wrd_global
-       IF ( wind_turbine )         CALL wtm_wrd_global
-!
-!--    Write restart data of the user-interface
-       CALL user_wrd_global
+       CALL module_interface_wrd_global
 
 
@@ -910,60 +894,7 @@
 !------------------------------------------------------------------------------!
     SUBROUTINE wrd_local
- 
-
-       USE arrays_3d,                                                          &
-           ONLY:  e, kh, km, p, pt, q, ql, s, u, u_m_l, u_m_n, u_m_r,          &
-                  u_m_s, v, v_m_l, v_m_n, v_m_r, v_m_s, vpt, w, w_m_l, w_m_n,  &
-                  w_m_r, w_m_s
-        
-       USE averaging
-
-       USE bulk_cloud_model_mod,                                               &
-           ONLY:  bulk_cloud_model, bcm_wrd_local
-
-       USE chemistry_model_mod,                                                &
-           ONLY:  chem_wrd_local
-
-       USE gust_mod,                                                           &
-           ONLY :  gust_module_enabled, gust_wrd_local
-                
-       USE indices,                                                            &
-           ONLY:  nxl, nxr, nys, nyn, nzb, nzt
-
-       USE land_surface_model_mod,                                             &
-           ONLY:  lsm_wrd_local
-
-       USE ocean_mod,                                                          &
-           ONLY:  ocean_wrd_local
-
-       USE particle_attributes,                                                &
-           ONLY:  iran_part
-
-       USE radiation_model_mod,                                                &
-           ONLY:  radiation, radiation_wrd_local
-    
-       USE random_function_mod,                                                &
-           ONLY:  random_iv, random_iy
-
-       USE random_generator_parallel,                                          &
-           ONLY:  id_random_array, seq_random_array
-              
-       USE salsa_mod,                                                          &
-           ONLY:  salsa_wrd_local          
-
-       USE surface_mod,                                                        &
-           ONLY :  surface_wrd_local
-
-       USE urban_surface_mod,                                                  &
-           ONLY:  usm_wrd_local    
-
-       USE user_write_restart_data_mod,                                        &
-           ONLY:  user_wrd_local 
-
-
-       IMPLICIT NONE
+
 
        CHARACTER (LEN=10) ::  binary_version_local   !< 
-
 
 !
@@ -1271,19 +1202,10 @@
        ENDIF
 
+
+       CALL surface_wrd_local
+
 !
 !--    Write restart data of other modules
-       IF ( bulk_cloud_model )     CALL bcm_wrd_local
-       IF ( air_chemistry )        CALL chem_wrd_local
-       IF ( gust_module_enabled )  CALL gust_wrd_local
-       IF ( land_surface )         CALL lsm_wrd_local
-       IF ( ocean_mode )           CALL ocean_wrd_local
-       IF ( radiation )            CALL radiation_wrd_local
-       IF ( salsa )                CALL salsa_wrd_local
-       CALL surface_wrd_local
-       IF ( urban_surface )        CALL usm_wrd_local
-
-!
-!--    Write user-defined restart data
-       CALL user_wrd_local
+       CALL module_interface_wrd_local
 
 !
